### Function

# Gio IOModule query

since: 2.24

#### Declaration

    char**
    g_io_module_query (
      void
    )

#### Description

Optional API for GIO modules to implement.

Should return a list of all the extension points that may be implemented in this module.

This method will not be called in normal use, however it may be called when probing existing modules and recording which extension points that this model is used for. This means we won’t have to load and initialize this module unless its needed.

If this function is not implemented by the module the module will always be loaded, initialized and then unloaded on application startup so that it can register its extension points during init.

Note that a module need not actually implement all the extension points that `g_io_module_query()` returns, since the exact list of extension may depend on runtime issues. However all extension points actually implemented must be returned by `g_io_module_query()` (if defined).

When installing a module that implements `g_io_module_query()` you must run gio-querymodules in order to build the cache files required for lazy loading.

Since 2.56, this function should be named `g_io_<modulename>_query`, where `modulename` is the plugin’s filename with the `lib` or `libgio` prefix and everything after the first dot removed, and with `-` replaced with `_` throughout. For example, `libgiognutls-helper.so` becomes `gnutls_helper`. Using the new symbol names avoids name clashes when building modules statically. The old symbol names continue to be supported, but cannot be used for static builds.

Available since: 2.24

#### Return value

Type: An array of `utf8`

A `NULL`-terminated array of strings, listing the supported extension points of the module. The array must be suitable for freeing with g_strfreev().

The array is `NULL`-terminated.
The caller of the function takes ownership of the data, and is responsible for freeing it.
Each element is a NUL terminated UTF-8 string.